﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Microsoft.AspNet.SignalR;
using System.Threading;
using System.Diagnostics;
using RealTimeChart.Models;
using Microsoft.AspNet.SignalR.Infrastructure;


namespace RealTimeChart
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            //  routes.IgnoreRoute("CPUDataStream/{*operation}");


            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );

        }

        protected void Application_Start()
        {
            
            RouteTable.Routes.MapConnection<CPUDataStream>("cpuDataStream", "/cpuDataStream");


            AreaRegistration.RegisterAllAreas();
            RegisterGlobalFilters(GlobalFilters.Filters);







      

            RegisterRoutes(RouteTable.Routes);

            ThreadPool.QueueUserWorkItem(_ =>
            {
                var context = GlobalHost.ConnectionManager.GetConnectionContext<CPUDataStream>();
                IConnection connection = context.Connection;

                var counter = new PerformanceCounter();
                counter.CategoryName = "Processor";
                counter.CounterName = "% Processor Time";
                counter.InstanceName = "_Total";

                var memCounter = new PerformanceCounter();
                memCounter.CategoryName = "Memory";
                memCounter.CounterName = "Available MBytes";


                while (true)
                {
                    var item = new CPUInfoItem()
                    {
                        DateString = DateTime.Now.ToString("hh:mm:ss"),
                        CPUUsage = Math.Round(counter.NextValue(), 2),
                        MemUsage = memCounter.NextValue()
                    };

                    connection.Broadcast(item);

                    Thread.Sleep(300);
                }
            });
        }
    }
}